﻿using Microsoft.Maui.Controls;
using System;

namespace Aufgabenpool_18
{
    public partial class MainPage : ContentPage
    {
        private string aktuell = "";
        private string operation = "";
        private double ergebnis = 0;

        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Clicked(object sender, EventArgs e)
        {
            Button button = (Button)sender;
            string buttonText = button.Text;

            if (buttonText == "C")
            {
                aktuell = "";
                operation = "";
                ergebnis = 0;
                UpdateAnzeige();
            }
            else if (buttonText == "=")
            {
                BerechneErgebnis();
            }
            else if (IstOperator(buttonText))
            {
                if (aktuell != "")
                {
                    operation = buttonText;
                    ergebnis = double.Parse(aktuell);
                    aktuell = "";
                    UpdateAnzeige();
                }
            }
            else
            {
                aktuell += buttonText;
                UpdateAnzeige();
            }
        }

        private bool IstOperator(string text)
        {
            return text == "+" || text == "-" || text == "*" || text == "/";
        }

        private void UpdateAnzeige()
        {
            anzeige.Text = aktuell;
        }

        private void BerechneErgebnis()
        {
            if (aktuell != "" && operation != "")
            {
                double eingabe = double.Parse(aktuell);

                switch (operation)
                {
                    case "+":
                        ergebnis += eingabe;
                        break;
                    case "-":
                        ergebnis -= eingabe;
                        break;
                    case "*":
                        ergebnis *= eingabe;
                        break;
                    case "/":
                        if (eingabe != 0)
                        {
                            ergebnis /= eingabe;
                        }
                        else
                        {
                            DisplayAlert("Fehler", "Division durch Null ist nicht erlaubt.", "OK");
                            aktuell = "";
                            operation = "";
                            ergebnis = 0;
                            UpdateAnzeige();
                            return;
                        }
                        break;
                }

                aktuell = ergebnis.ToString();
                operation = "";
                UpdateAnzeige();
            }
        }
    }
}
