using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Aufgabenpool_Kapitel_14
{
    public partial class CExplorer : Form
    {
        //Diese Verzeichnisnamen drfen eigentlich nicht benutzt werden!!!
        const string dummy = "?";
        const string gefllt = "*";
        private string aktuellesVerzeichnis;

        public CExplorer()
        {
            InitializeComponent();
            listView1.GridLines = true;
            
        }

        private void btnVerzeichnis_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.ShowDialog();
            string verzeichnis = folderBrowserDialog1.SelectedPath;

            TreeNode wurzel = new TreeNode(verzeichnis);
            treeView1.Nodes.Add(wurzel);
            treeView1.Name = verzeichnis;
            treeView1.ImageList = new ImageList();
            
            treeView1.ImageList.Images.Add(Bitmap.FromFile("Ordner.ico"));
            treeView1.ImageList.Images.Add(Bitmap.FromFile("Rad.ico"));

            treeView1.ImageIndex = 0;
            treeView1.SelectedImageIndex = 1;

            string[] unterverzeichnisse = System.IO.Directory.GetDirectories(wurzel.FullPath);
            if (unterverzeichnisse.Length > 0) wurzel.Nodes.Add(dummy);

        }

        private void KnotenFllen(TreeNode wurzel)
        {

            foreach (TreeNode suchen in wurzel.Nodes)
            {
                //Entfernen des dummys
                if (suchen.Text == dummy) suchen.Remove();

                //Abbruch, falls der Knoten bereits gefllt mit Lschen des gefllt-Knotens
                if (suchen.Text == gefllt) { suchen.Remove(); return; }

            }

            //Abfragen der Verzeichnisse
            System.IO.DirectoryInfo verzeichnisse = new System.IO.DirectoryInfo(wurzel.FullPath);

            //Anlegen der Knoten
            foreach (System.IO.DirectoryInfo dir in verzeichnisse.GetDirectories())
            {

                TreeNode Knoten = new TreeNode(dir.Name);
                wurzel.Nodes.Add(Knoten);

                //Check, ob Unterverzeichnisse da sind und Anlegen eines dummy-Knotens nach Bedarf
                string[] unterverzeichnisse = System.IO.Directory.GetDirectories(dir.FullName);
                if (unterverzeichnisse.Length > 0) Knoten.Nodes.Add(dummy);

            }

        }

        private void treeView1_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            //Beim Expandieren wird der aktuelle Knoten gefllt
            KnotenFllen(e.Node);
        }

        private void treeView1_AfterCollapse(object sender, TreeViewEventArgs e)
        {
            //Einfgen eines Unterknoten, der zeigt, dass der Knoten bereits gefllt wurde
            e.Node.Nodes.Add(gefllt);
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
                        
            listView1.Items.Clear();

            string [] dateien = System.IO.Directory.GetFiles(e.Node.FullPath,"*.txt");
            aktuellesVerzeichnis = e.Node.FullPath;

            foreach (string s in dateien)
            {
                
                //Das Datum der Datei holen
                string datum = Convert.ToString(System.IO.File.GetCreationTime(s));
                
                //Nur den Namen holen
                string[] teile = s.Split('\\');
                string name = teile[teile.Length - 1];
                
                //MessageBox.Show(name);
                
                //In die ListView einfgen
                ListViewItem li = new ListViewItem(name);
                li.SubItems.Add(datum);
                listView1.Items.Add(li);
            }

        }

        private void listView1_Click(object sender, EventArgs e)
        {
            ListViewItem liSel = listView1.SelectedItems[0];

            string dateiSel = aktuellesVerzeichnis + '\\' + liSel.Text;

            textBox1.Text = System.IO.File.ReadAllText(dateiSel);
                        
        }

     
    
    }
}