using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Aufgabenpool_Kapitel_14
{
    public partial class CGrafikanwendung : Form
    {

        bool Zeichnen = false;
        bool Neu = false;

        char status = 'E';
        private Point[] Punkte = new Point[5];
        private Rectangle R = new Rectangle();
        private System.Collections.ArrayList EListe = new System.Collections.ArrayList();
        private System.Collections.ArrayList RListe = new System.Collections.ArrayList();
        private System.Collections.ArrayList LListe = new System.Collections.ArrayList();

        //MausKoordinaten
        private int X, Y;


        public CGrafikanwendung()
        {
            InitializeComponent();
            this.ResizeRedraw = true;

        }

        private void ladenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
            string[] Zeilen = System.IO.File.ReadAllLines(openFileDialog1.FileName);

            RListe.Clear();
            EListe.Clear();
            LListe.Clear();

            foreach (string s in Zeilen)
            {
                string[] teile = s.Split(',');

                R.X = Convert.ToInt32(teile[1]);
                R.Y = Convert.ToInt32(teile[2]);
                R.Width = Convert.ToInt32(teile[3]);
                R.Height = Convert.ToInt32(teile[4]);

                switch (teile[0])
                {
                    case "R":
                        RListe.Add(R);
                        break;

                    case "E":
                        EListe.Add(R);
                        break;

                    case "L":
                        LListe.Add(R);
                        break;
                }
            }

            rechteckToolStripMenuItem.Checked = false;
            ellipseToolStripMenuItem.Checked = false;
            linieToolStripMenuItem.Checked = false;
            status = ' ';

            Invalidate();

        }

        private void speichernToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string[] Zeilen = new string[RListe.Count + EListe.Count + LListe.Count];
            int i = 0;

            foreach (object o in RListe)
            {
                R = (Rectangle)o;
                Zeilen[i] = "R," + R.X + "," + R.Y + "," + R.Width + "," + R.Height;
                i++;
            }

            foreach (object o in EListe)
            {
                R = (Rectangle)o;
                Zeilen[i] = "E," + R.X + "," + R.Y + "," + R.Width + "," + R.Height;
                i++;
            }

            foreach (object o in LListe)
            {
                R = (Rectangle)o;
                Zeilen[i] = "L," + R.X + "," + R.Y + "," + R.Width + "," + R.Height;
                i++;
            }

            saveFileDialog1.ShowDialog();
            System.IO.File.WriteAllLines(saveFileDialog1.FileName, Zeilen);

        }

        private void rechteckToolStripMenuItem_Click(object sender, EventArgs e)
        {
            rechteckToolStripMenuItem.Checked = true;
            ellipseToolStripMenuItem.Checked = false;
            linieToolStripMenuItem.Checked = false;
            status = 'R';

        }

        private void ellipseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            rechteckToolStripMenuItem.Checked = false;
            ellipseToolStripMenuItem.Checked = true;
            linieToolStripMenuItem.Checked = false;
            status = 'E';
        }

        private void linieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            rechteckToolStripMenuItem.Checked = false;
            ellipseToolStripMenuItem.Checked = false;
            linieToolStripMenuItem.Checked = true;
            status = 'L';
        }

        protected override void OnResize(System.EventArgs e)
        {
            Invalidate();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Graphics gra = e.Graphics;

            foreach (object o in EListe)
            {
                Rectangle dummy = (Rectangle)o;
                gra.DrawEllipse(new Pen(Brushes.Blue), dummy);
            }

            foreach (object o in RListe)
            {
                Rectangle dummy = (Rectangle)o;
                gra.DrawRectangle(new Pen(Brushes.Blue), dummy);
            }

            foreach (object o in LListe)
            {
                Rectangle dummy = (Rectangle)o;
                Point[] P = new Point[2];
                P[0].X = dummy.X;
                P[0].Y = dummy.Y + dummy.Height;
                P[1].X = dummy.X + dummy.Width;
                P[1].Y = dummy.Y;

                gra.DrawPolygon(new Pen(Brushes.Blue), P);
            }


        }

        protected override void OnMouseDown(MouseEventArgs e)
        {
            Punkte[0].X = e.X;
            Punkte[0].Y = e.Y;
            Zeichnen = true;
            Neu = true;
        }

        protected override void OnMouseUp(MouseEventArgs e)
        {

            Zeichnen = false;
            switch (status)
            {
                case 'E':
                    EListe.Add(R);
                    break;

                case 'R':
                    RListe.Add(R);
                    break;

                case 'L':
                    LListe.Add(R);
                    break;

            }
            Neu = false;

            Invalidate();

        }

        protected override void OnMouseMove(MouseEventArgs e)
        {
            if (Zeichnen == true)
            {

                Graphics gra = CreateGraphics();

                if (Neu != true)
                {
                    switch (status)
                    {
                        case 'E':
                            gra.DrawEllipse(new Pen(this.BackColor), R);
                            break;

                        case 'R':
                            gra.DrawRectangle(new Pen(this.BackColor), R);
                            break;

                        case 'L':
                            Point[] P = new Point[2];
                            P[0].X = R.X;
                            P[0].Y = R.Y + R.Height;
                            P[1].X = R.X + R.Width;
                            P[1].Y = R.Y;

                            gra.DrawPolygon(new Pen(this.BackColor), P);
                            break;

                    }
                }
               

                Punkte[2].X = e.X;
                Punkte[2].Y = e.Y;

                Punkte[1].X = Punkte[0].X;
                Punkte[1].Y = Punkte[2].Y;
                Punkte[3].X = Punkte[2].X;
                Punkte[3].Y = Punkte[0].Y;
                Punkte[4] = Punkte[0];


                R.X = Punkte[0].X;
                R.Y = Punkte[1].Y;
                R.Width = Punkte[2].X - Punkte[0].X;
                R.Height = Punkte[0].Y - Punkte[1].Y;

                switch (status)
                {
                    case 'E':
                        gra.DrawEllipse(new Pen(Brushes.Blue), R);
                        break;

                    case 'R':
                        gra.DrawRectangle(new Pen(Brushes.Blue), R);
                        break;

                    case 'L':
                        Point[] P = new Point[2];
                        P[0].X = R.X;
                        P[0].Y = R.Y + R.Height;
                        P[1].X = R.X + R.Width;
                        P[1].Y = R.Y;


                        gra.DrawPolygon(new Pen(Brushes.Blue), P);
                        break;

                }

                Neu = false;

                gra.Dispose();
            }
        }

        private void infoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Grafik-Anwendung <c> Dirk Hardy");
        }

        private void allesLschenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            RListe.Clear();
            EListe.Clear();
            LListe.Clear();
            Invalidate();
            status = ' ';

        }

    }

}