﻿using System;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;



namespace Aufgabenpool_Kapitel_16__WPF_
{
    /// <summary>
    /// Interaktionslogik für Baumansicht.xaml
    /// </summary>
    public partial class Baumansicht : Window
    {

        private string [] zeilen;
        private ArrayList mListe = new ArrayList();
        private ArrayList aListe = new ArrayList();
        
        private ArrayList aNamen = new ArrayList();

        public Baumansicht()
        {
            InitializeComponent();
        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            MenuItem befehl = (MenuItem)sender;

            if (befehl.Header.ToString() == "Öffnen")
            {
                System.Windows.Forms.OpenFileDialog dlg = new System.Windows.Forms.OpenFileDialog();
                dlg.ShowDialog();
                FuelleListen(dlg.FileName);
                FuelleBaum();
            }
            else
                this.Close();
        }

   
        private void FuelleListen(string datei)
        {
            zeilen = System.IO.File.ReadAllLines(datei);
            string [] teile;
            
            foreach (string z in zeilen)
            {
                teile = z.Split(';');
                mListe.Add(new CMitarbeiter(teile[0],teile[1],teile[2],teile[3]));
            }

            foreach (CMitarbeiter m in mListe)
            {
                if (!aNamen.Contains(m.GetAbteilung()))
                {
                    aNamen.Add(m.GetAbteilung());
                }
            }
        
            foreach (string n in aNamen)
            {
                aListe.Add(new CAbteilung(n,mListe));
            }


        }


        private void FuelleBaum()
        {
            TreeViewItem mKnoten = new TreeViewItem();
            mKnoten.Header = "Mitarbeiter";
            treeView1.Items.Add(mKnoten);
            TreeViewItem aKnoten = new TreeViewItem();
            aKnoten.Header = "Abteilungen";
            treeView1.Items.Add(aKnoten);

                        

            foreach (CAbteilung a in aListe)
            {
                TreeViewItem knoten = new TreeViewItem();
                knoten.Header = a.GetName();
                aKnoten.Items.Add(knoten);

                
                TreeViewItem leitung = new TreeViewItem();
                leitung.Header="Leitung";
                TreeViewItem mitarbeiter = new TreeViewItem();
                mitarbeiter.Header="Mitarbeiter";

                knoten.Items.Add(leitung);
                knoten.Items.Add(mitarbeiter);

                string leitungsName = "";
                foreach (CMitarbeiter m in a.GetListe())
                {
                    mitarbeiter.Items.Add(m.GetName());
                    if (m.GetID() == m.GetLeitung())
                        leitungsName = m.GetName();
                }
                a.SetLeitungsName(leitungsName);
                leitung.Items.Add(leitungsName);

            }


            foreach (CMitarbeiter m in mListe)
            {
                string abteilungsLeitung = "";
                TreeViewItem knoten = new TreeViewItem();
                knoten.Header=m.GetName();
                mKnoten.Items.Add(knoten);

                foreach (CAbteilung a in aListe)
                {
                    if (a.GetName() == m.GetAbteilung())
                    {
                        abteilungsLeitung = a.GetLeitungsName();
                        break;
                    }
                }

                knoten.Items.Add(m.GetAbteilung() + " (Leitung: " + abteilungsLeitung + ")");

            }
        }

    }

    class CMitarbeiter
    {
        private string name;
        private string id;
        private string abteilung;
        private string leitung;
     

        public CMitarbeiter(string i, string n, string a, string l)
        {
            name = n;
            id = i;
            abteilung = a;
            leitung = l;
        }

        public string GetName()
        {
            return name;
        }

        public string GetID()
        {
            return id;
        }

        public string GetAbteilung()
        {
            return abteilung;
        }

        public string GetLeitung()
        {
            return leitung;
        }

      
    }

    class CAbteilung
    {
        string name;
        ArrayList mListe = new ArrayList();
        private string leitungsName;


        public CAbteilung(string n, ArrayList liste)
        {
            name = n;
            foreach (CMitarbeiter m in liste)
            {
                if (m.GetAbteilung() == name)
                {
                    mListe.Add(m);
                }
            }
        }

        public string GetName()
        {
            return name;
        }

        public ArrayList GetListe()
        {
            return mListe;
        }

        public string GetLeitungsName()
        {
            return leitungsName;
        }

        public void SetLeitungsName(string name)
        {
            leitungsName = name;
        }

    }

}

