﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;


namespace Aufgabenpool_Kapitel_17
{

    class Program
    {
        static void Auswertung()
        {

            //Verbindungsstring
            string verbindungsstring = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\\Temp\\Artikel.accdb;";


            OleDbConnection dBVerbindung = null;
            OleDbCommand befehl = null;
            OleDbDataReader datenleser = null;

            bool offen = false;

            try
            {
                dBVerbindung = new OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();

                //Erste Abfrage
                befehl.CommandText = "SELECT * FROM Artikel ORDER BY Anzahl DESC;";

                datenleser = befehl.ExecuteReader();

                Console.WriteLine("Die drei Artikel mit der höchsten Anzahl:");
                for (int i = 0; i < 3; i++)
                {
                    if (datenleser.Read())
                        Console.WriteLine(datenleser.GetString(0) + "  (" + datenleser.GetInt32(1) + ")");

                }
                Console.WriteLine();
                datenleser.Close();

                //Zweite Abfrage
                befehl.CommandText = "SELECT * FROM Artikel ORDER BY Anzahl ASC;";

                datenleser = befehl.ExecuteReader();

                Console.WriteLine("Die drei Artikel mit der niedrigsten Anzahl:");
                for (int i = 0; i < 3; i++)
                {
                    if (datenleser.Read())
                        Console.WriteLine(datenleser.GetString(0) + "  (" + datenleser.GetInt32(1) + ")");

                }
                Console.WriteLine();
                datenleser.Close();

                //Dritte Abfrage
                befehl.CommandText = "SELECT AVG(Anzahl) FROM Artikel;";

                datenleser = befehl.ExecuteReader();

                Console.Write("Die durchschnittliche Artikelanzahl lautet:  ");
                if (datenleser.Read())
                    Console.WriteLine(datenleser.GetDouble(0));

                Console.WriteLine();
                datenleser.Close();



            }
            catch (Exception ausnahme)
            {
                Console.WriteLine("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }

        }

        static void SchreibeDaten()
        {

            //Datei lesen
            string[] zeilen = System.IO.File.ReadAllLines("c:/temp/inventur.txt");


            //Verbindungsstring
            string verbindungsstring = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\\Temp\\Artikel.accdb;";


            OleDbConnection dBVerbindung = null;
            OleDbCommand befehl = null;
            bool offen = false;


            try
            {
                dBVerbindung = new OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();

                for (int i = 0; i < zeilen.Length; i += 2)
                {
                    befehl.CommandText = "INSERT INTO Artikel VALUES ('" + zeilen[i] + "'," + zeilen[i + 1] + ");";

                    befehl.ExecuteNonQuery();

                }

            }
            catch (Exception ausnahme)
            {
                Console.WriteLine("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }
        }

        static void Main(string[] args)
        {

            SchreibeDaten();
            Auswertung();
        }
    }



}
