﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;


namespace Informationsteil_Kapitel_17
{
    class CDBZugriff
    {


        static void Kapitel_17_1_3()
        {

            //ACCESS 2000 für *.mdb-Dateien
            //string verbindungsstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Temp\\Kunden.mdb";

            //ACCESS ab 2007
            string verbindungsstring = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\\Temp\\Kunden.accdb;";


            OleDbConnection dBVerbindung = null;
            OleDbCommand befehl = null;
            OleDbDataReader datenleser = null;

            bool offen = false;

            try
            {
                dBVerbindung = new OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();
                befehl.CommandText = "SELECT * FROM Kunden";

                datenleser = befehl.ExecuteReader();

                while (datenleser.Read())
                {
                    Console.WriteLine("Name: " + datenleser.GetString(1));
                }
                Console.WriteLine();

            }
            catch (Exception ausnahme)
            {
                Console.WriteLine("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }

        }

        static void Kapitel_17_1_4()
        {

            //ACCESS 2000 für *.mdb-Dateien
            //string verbindungsstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Temp\\Kunden.mdb";

            //ACCESS ab 2007
            string verbindungsstring = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\\Temp\\Kunden.accdb;";


            OleDbConnection dBVerbindung = null;
            OleDbCommand befehl = null;
            bool offen = false;
            int anzahl = 0;

            try
            {
                dBVerbindung = new OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();

                befehl.CommandText = "INSERT INTO Kunden VALUES (4,'König','Seestr. 5','Hamburg','45621');";

                anzahl = befehl.ExecuteNonQuery();


                Console.WriteLine("Anzahl der eingefügten Zeilen: " + anzahl);



                befehl.CommandText = "UPDATE Kunden SET Telefon = '11111' WHERE Name = 'Hansen';";
                anzahl = befehl.ExecuteNonQuery();
                Console.WriteLine("Anzahl der geänderten Zeilen: " + anzahl);

                befehl.CommandText = "DELETE FROM Kunden WHERE Name = 'Knudsen';";
                anzahl = befehl.ExecuteNonQuery();
                Console.WriteLine("Anzahl der gelöschten Zeilen: " + anzahl);
                Console.WriteLine();


            }
            catch (Exception ausnahme)
            {
                Console.WriteLine("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }
        }

        static void Kapitel_17_1_5()
        {

            //ACCESS 2000 für *.mdb-Dateien
            //string verbindungsstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Temp\\Kunden.mdb";

            //ACCESS ab 2007
            string verbindungsstring = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\\Temp\\Kunden.accdb";


            OleDbConnection dBVerbindung = null;
            OleDbCommand befehl = null;

            bool offen = false;

            try
            {
                dBVerbindung = new OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();
                befehl.CommandText = "SELECT * FROM Kunden";

                OleDbDataAdapter da = new OleDbDataAdapter(befehl);
                DataSet ds = new DataSet();
                da.Fill(ds);

                for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                {
                    Console.WriteLine(ds.Tables[0].Rows[i]["name"].ToString());
                }

                ds.Tables[0].Rows[0]["name"] = "Laufer";



                DataRow zeile = ds.Tables[0].NewRow();
                zeile["id"] = 10;
                zeile["name"] = "Kaiser";
                ds.Tables[0].Rows.Add(zeile);

                ds.Tables[0].Rows[1].Delete();

                OleDbCommandBuilder cmb = new OleDbCommandBuilder(da);
                da.Update(ds);
                Console.WriteLine();


            }
            catch (Exception ausnahme)
            {
                Console.WriteLine("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }
        }



        static void Main(string[] args)
        {

            Kapitel_17_1_3();
            //Kapitel_17_1_4();
            //Kapitel_17_1_5();

        }
    }
}
