﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Lernsituation_6
{
    public partial class Form1 : Form
    {

        //Hier den Pfad gegebenenfalls anpassen
        private string verbindungsstring = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\\Temp\\Termine.accdb;";
        System.Data.OleDb.OleDbConnection dBVerbindung = null;
        System.Data.OleDb.OleDbCommand befehl = null;
        System.Data.OleDb.OleDbDataReader datenleser = null;
        
        public Form1()
        {
            InitializeComponent();
            StartTerminListeFuellen();                
        }


        public void StartTerminListeFuellen()
        {
            
            bool offen = false;
            ListViewItem Eintrag;
            listViewTermine.Items.Clear();


            try
            {
                dBVerbindung = new System.Data.OleDb.OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();
                befehl.CommandText = "SELECT * FROM Kontakte K, Termine T WHERE K.K_ID = T.K_ID ORDER BY T.Datum ASC;";

                datenleser = befehl.ExecuteReader();

                while (datenleser.Read())
                {
                    Eintrag = new ListViewItem(datenleser.GetDateTime(datenleser.GetOrdinal("Datum")).ToString().Split(' ')[0]);
                    Eintrag.SubItems.Add(datenleser.GetString(datenleser.GetOrdinal("Uhrzeit")).ToString());
                    Eintrag.SubItems.Add(datenleser.GetString(datenleser.GetOrdinal("Beschreibung")).ToString());
                    Eintrag.SubItems.Add(datenleser.GetString(datenleser.GetOrdinal("Name")).ToString());
                    
                    listViewTermine.Items.Add(Eintrag);

                }

            }
            catch (Exception ausnahme)
            {
                MessageBox.Show("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }

        }

        public int GetMaxID(string tabelle)
        {

            bool offen = false;
            int max = 0;

            try
            {
                dBVerbindung = new System.Data.OleDb.OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();

                if (tabelle == "Kontakte")
                    befehl.CommandText = "SELECT MAX(K_ID) FROM Kontakte;";
                else
                    befehl.CommandText = "SELECT MAX(T_ID) FROM Termine;";


                datenleser = befehl.ExecuteReader();

                while (datenleser.Read())
                {
                    max = datenleser.GetInt32(0);                
                }

            }
            catch (Exception ausnahme)
            {
                MessageBox.Show("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }


            return max;
        }

        private void eNDEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }


        
        private void neuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Kontakt kdlg = new Kontakt();

            kdlg.ShowDialog();

            if (kdlg.speichern == false) return;

            
            bool offen = false;

            int max = GetMaxID("Kontakte") + 1;

            
            try
            {
                dBVerbindung = new System.Data.OleDb.OleDbConnection(verbindungsstring);
                dBVerbindung.Open();
                offen = true;

                befehl = dBVerbindung.CreateCommand();


                befehl.CommandText = kdlg.GetSQLInsert(max);
                
                befehl.ExecuteNonQuery();

      

            }
            catch (Exception ausnahme)
            {
                MessageBox.Show("Datenbankfehler: " + ausnahme.Message);
            }
            finally
            {
                if (offen == true) dBVerbindung.Close();
            }


            StartTerminListeFuellen();

        }

        private void listeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Kontaktliste kliste = new Kontaktliste();
            kliste.ShowDialog();
            kliste.KontaktListeFuellen();
        }

        private void neuToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Termine termin = new Termine();
            termin.ShowDialog();
            
        }
    }
}
